from __future__ import generators
import sys, socket

class Server:
    def open(self, host, port):
        self.s = s = socket.socket()
        s.connect((host, port))
        self.data = []

    def close(self):
        if self.closed:
            return
        self.s.close()

    def __del__(self):
        self.close()

    def write(self, data):
        datalen = len(data)
        s = self.s
        while datalen:
            sent = s.send(data)
            datalen = datalen - sent
            data = data[sent:]

    def tokens(self):
        s = self.s
        data = []
        while 1:
            raw = s.recv(2000)
            line_list = raw.split('\n')
            new_data = line_list.pop(0)
            if line_list:
                data.append(new_data)
                for token in ''.join(data).split():
                    yield token
                yield None
                data = []
                new_data = line_list.pop()
                for line in line_list:
                    for token in line.split():
                        yield token
                    yield None
            if new_data:
                if ' ' in new_data:
                    tokens = new_data.split()
                    data.append(tokens.pop(0))
                    yield ''.join(data)
                    if new_data[-1] == ' ':
                        data = []
                    else:
                        data = [tokens.pop()]
                    for token in tokens:
                        yield token
                else:
                    data.append(new_data)
                

        
